<template>
    <div style="display: flex; justify-content: center; margin-top: 50px">
        <FilterForm :form="form" @submit="search"/>
    </div>

    <div v-if="getHousesIsLoading">
        <el-row>
            <el-col v-for="i in 9" :lg="8" :sm="12" :xs="24">
                <HouseSkeleton/>
            </el-col>
        </el-row>
    </div>
    <div v-else-if="getHouses">
        <el-row>
            <el-col v-for="house in getHouses" :lg="8" :sm="12" :xs="24">
                <House :house="house"/>
            </el-col>
        </el-row>

        <div v-if="getHouses.length === 0">
            <el-empty description="Not Found" />
        </div>

        <div v-else style="display: flex; justify-content: center; margin-top: 50px">
            <el-pagination v-if="getHousesMeta"
                           v-model:current-page="currentPage"
                           v-model:page-size="pageSize"
                           :page-sizes="[9, 18, 27]"
                           :background="true"
                           layout="sizes, prev, pager, next"
                           :total="getHousesMeta.total"
                           @size-change="filter"
                           @current-change="filter"
            />
        </div>
    </div>
</template>

<script>
import {mapGetters} from "vuex";
import House from "@/components/Houses/House.vue";
import FilterForm from "@/components/Houses/FilterForm.vue";
import HouseSkeleton from "@/components/Houses/HouseSkeleton.vue";

export default {
    name: "Houses",
    components: {HouseSkeleton, FilterForm, House},
    mounted() {
        this.filter()
    },
    data() {
        return {
            currentPage: 1,
            pageSize: 9,
            form: {
                name: null,
                bedrooms: null,
                bathrooms: null,
                storeys: null,
                garages: null,
                price: null,
            },
            filterParams: null
        }
    },
    computed: {
        ...mapGetters([
            'getHouses',
            'getHousesMeta',
            'getHousesIsLoading',
        ]),
    },
    methods: {
        filter() {
            const data = {
                per_page: this.pageSize,
                page: this.currentPage,
                name: this.filterParams?.name,
                bedrooms: this.filterParams?.bedrooms,
                bathrooms: this.filterParams?.bathrooms,
                storeys: this.filterParams?.storeys,
                garages: this.filterParams?.garages,
                price: this.filterParams?.price,
            }

            this.$store.dispatch('getHouses', data).then((response) => {
                this.currentPage = response.meta.current_page
                this.pageSize = response.meta.per_page
            })
        },
        search() {
            this.filterParams = this.form
            this.currentPage = 1;
            this.filter()
        }
    }
}
</script>
